# generated by datamodel-codegen:
#   filename:  services_v1.json

from __future__ import annotations

from typing import Dict, Optional

from pydantic import BaseModel, ConfigDict, constr


class Services(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        frozen=True,
    )
    compatible_range: Optional[str] = None
    """
    The `compatible_range` property specifies a semantic version range (see https://www.npmjs.com/package/semver).<br/>Changes that might trigger some action on the client side can be described using appropriate values of `compatible_range`, independent of the value of version. For example, it may be possible that there is a functionally incompatible version change (say 1.2.3 to 2.0.0) that does not change output characteristics and therefore does not require any action on the part of the client, so compatible_range can be `>=1.2.3 <=2.0.0`.<br/><br/>*NOTE* Interface changes are not tracked using this mechanism.<br/><br/>In the case of the pdf_structure service, if a client is asked to redisplay a cached version of a file that has previously been processed by this service, the client should compare the version of the service that performed the original conversion against the compatibility range. If the range test fails, then the client is recommended to re-process the file through the service.
    """
    version: constr(pattern=r'^\d+\.\d+\.\d+(-[0-9A-Za-z-]+)?(\+[0-9A-Za-z-\.]+)?$')
    """
    The `version` property gives the current version of the service in semantic version format (see http://semver.org/).
    """


class Model(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        frozen=True,
    )
    services: Optional[Dict[str, Services]] = None
