# generated by datamodel-codegen:
#   filename:  system_folders_v1.json

from __future__ import annotations

from typing import Dict, Optional

from pydantic import AnyUrl, BaseModel, ConfigDict


class CreativeCloud(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        frozen=True,
    )
    folder_id: str
    """
    The folder id (in URN form).
    """
    root_uri: AnyUrl
    """
    The URI of the creative cloud root folder.
    """


class DocumentCloud(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        frozen=True,
    )
    folder_id: str
    """
    The folder id (in URN form).
    """
    root_uri: AnyUrl
    """
    The URI of the document cloud root folder.
    """


class Roots(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        frozen=True,
    )
    creative_cloud: Optional[CreativeCloud] = None
    document_cloud: DocumentCloud


class SystemFolders(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        frozen=True,
    )
    folder_id: str
    """
    The folder id (in URN form).
    """
    folder_uri: AnyUrl
    """
    URI representing the system folder.
    """


class Model(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        frozen=True,
    )
    roots: Roots
    """
    An object with a field for each root folder available to this user.
    """
    system_folders: Dict[str, SystemFolders]
    """
    An object containing a field for each system folder available to this user. The name of the property is the name of the system folder.  By nature these system folders are often considered private to the service that needs them, so the exact names aren't documented here.
    """
