# generated by datamodel-codegen:
#   filename:  user_limits_send_v1.json

from __future__ import annotations

from pydantic import BaseModel, ConfigDict


class Model(BaseModel):
    model_config = ConfigDict(
        extra='allow',
        frozen=True,
    )
    can_custom_brand: bool
    """
    Users who have purchased a subscription to the service can add custom branding to the shared files recipients page.
    """
    can_send_av: bool
    """
    Users who have purchased a subscription to the service can send audio or video files to recipients.<br/>If this limit is false, a parcel created that includes audio or video files will fail with an error from the API request.
    """
    can_send_to_individuals: bool
    """
    Users who have purchased a subscription to the service can have custom e-mails sent to recipients. Free users can generate only a single public url that they can paste into an e-mail or post on discussion boards.<br/>If this limit is `false`, a parcel created that includes recipients other than the constant `PARCEL_PUBLIC_SHARING` will result in an error from the API request.
    """
    max_daily_send: float
    """
    The maximum number of emails the user can send in a day through the Send & Track service. This is based on the user's subscription and will initially be set to 50 for free users and 2500 for paid users. This setting is intended to replace the can_send_to_individuals setting, which will eventually be removed.
    """
    max_send_recipients: float
    """
    The maximum number of recipients that can be added to an individual parcel. This is based on the user's subscription and will initially be set to 10 for free users and 250 for paid users.
    """
